<template>
    <div>
   <v-card
        class="mx-auto pa-8 pb-5 mt-10"
        elevation="8"
        max-width="448"
        rounded="lg"
        
      >
      <h1 style="text-align: center;">Sign up</h1>
       <vakidation-errors :validationErrors="errors"/>

      <div class="text-subtitle-1 text-medium-emphasis">Username</div>
  
        <v-text-field
          density="compact"
          placeholder="Username"
          prepend-inner-icon="mdi-email-outline"
          variant="outlined"
          v-model="username"
        ></v-text-field>
        <div class="text-subtitle-1 text-medium-emphasis">Account</div>
  
        <v-text-field
          density="compact"
          placeholder="Email address"
          prepend-inner-icon="mdi-email-outline"
          variant="outlined"
          v-model="email"
        ></v-text-field>
  
        <div class="text-subtitle-1 text-medium-emphasis d-flex align-center justify-space-between">
          Password
          <a
            class="text-caption text-decoration-none text-blue"
            href="#"
            rel="noopener noreferrer"
            target="_blank"
          >
            Forgot login password?</a>
        </div>
  <v-text-field
          :append-inner-icon="visible ? 'mdi-eye-off' : 'mdi-eye'"
          :type="visible ? 'text' : 'password'"
          density="compact"
          placeholder="Enter your password"
          prepend-inner-icon="mdi-lock-outline"
          variant="outlined"
          @click:append-inner="visible = !visible"
          v-model="password"
        ></v-text-field>
  
        <v-btn
          block
          class="mb-8"
          color="blue"
          size="large"
          variant="tonal"
          :disabled="isloading"
          @click="submitHeandler"
        >
          Sign up
        </v-btn>
      </v-card>
    </div>
  </template>
  <script>
import VakidationErrors from './VakidationErrors.vue'

export default{
  components:{
    VakidationErrors,
  },
    data() {
        return {
            visible: false,
            username: "",
            email: "",
            password: "",
         errors:{}
        
        };
    },
    methods: {
        submitHeandler(e) {
            e.preventDefault();
            const data = {
                username: this.username,
                password: this.password,
                email: this.email
            };
            this.$store.dispatch('register', data)
                .then((user) => {
                console.log("User", user);
                this.$router.push({ name: "Home" });
            })
                .catch(err => {
                this.errors=err.response.data.errors
                console.log(this.errors)
            });
        },
    },
    computed: {
        isloading() {
            return this.$store.state.auth.isLoading;
        },
        // errorMessage(){
        //   return  Objects.keys(this.valdationErrors).map(name=>{
        //     const msg = this.valdationErrors[name].join(', ')
        //     return `${name} ${msg}`
        //   })
        // }
    },
}
</script>